/*  This file is part of the KDE project
    Copyright (C) 2007 Matthias Kretz <kretz@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) version 3.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef AUDIOOUTPUT_H
#define AUDIOOUTPUT_H

#include <phonon/audiooutputinterface.h>
#include <QtCore/QObject>
#include "proxyobject.h"

namespace Phonon
{
namespace Proxy
{

class AudioOutput : public QObject, public AudioOutputInterface, public ProxyObject
{
    Q_OBJECT
    Q_INTERFACES(Phonon::AudioOutputInterface)
    public:
        AudioOutput(QObject *parent);
        ~AudioOutput();
        void handleSignal(SignalId, QDataStream &) const;
        QObject *qObject() { return this; }

        // Attributes Getters:
        qreal volume() const;
        int outputDevice() const;

        // Attributes Setters:
        void setVolume(qreal newVolume);
        bool setOutputDevice(int newDevice);

    Q_SIGNALS:
        // for the Frontend
        void volumeChanged(qreal newVolume) const;
        void audioDeviceFailed() const;
};
}} //namespace Phonon::Proxy

#endif // AUDIOOUTPUT_H
